﻿using Infragistics.Controls.Grids;
using Infragistics.Controls.Grids.Primitives;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamGridHierarchyScrollingCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();
        }

        private void XamGrid_RowExpansionChanged(object sender, Infragistics.Controls.Grids.RowExpansionChangedEventArgs e)
        {
            Row row = e.Row as Row;

            List<Row> visibleRows = theGrid.Rows.Where(r => r.Control != null).ToList();
            int visibleRowCount = visibleRows.Count;

            if (row ==  visibleRows[visibleRows.Count - 1] && row.IsExpanded)
            {
                ChildBandCollection cbc = row.ChildBands;
                if (cbc.Count != 0)
                {
                    ChildBand band = cbc[0];

                    Row childRow;

                    if (band.Rows.Count > visibleRowCount - 3)
                    {
                        childRow = band.Rows[visibleRowCount - 3];
                    }
                    else
                    {
                        childRow = band.Rows[band.Rows.Count - 1];
                    }

                    theGrid.ScrollCellIntoView(childRow.Cells[0]);                   
                }
            }
        }
    }
}
