﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XamGridHierarchyScrollingCase
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }

        Random r = new Random();
        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            for (int i = 0; i < 50; i++)
            {
                Data.Add(new SampleData()
                {
                    ID = i,
                    Label = "Label " + i.ToString(),
                    RandomNumber = r.Next(1000)
                });
            }
        }
    }

    public class SampleData
    {
        public ObservableCollection<ChildData> Children { get; set; }

        public int ID { get; set; }
        public string Label { get; set; }
        public int RandomNumber { get; set; }

        public SampleData()
        {
            Children = new ObservableCollection<ChildData>();

            for (int i = 0; i < 100; i++)
            {
                Children.Add(new ChildData()
                {
                    ChildID = i,
                    ChildLabel = "Child Label " + i.ToString()
                });
            }
        }
    }

    public class ChildData
    {
        public int ChildID { get; set; }
        public string ChildLabel { get; set; }
    }
}
